// Run this program on a staged multi-satellite deploy mission. (e.g. using a fairing with interstage nodes and stack separators) To use:
//
// 1. Make sure the next stage will decouple a satellite and activate its engines.
// 2. Pull up the PAW for the satellite's probe core and "Control from Here", so KSP stays focused on the satellite after deploy.
// 3. Run this program from that satellite's computer.
//
// This program will decouple the satellite and circularize its orbit. Ideally done on a resonant satellite injection orbit.

@lazyglobal off.

parameter name is "New Satellite".

RunOncePath("/lib/navigation").
RunOncePath("/lib/systems").

stage.

wait until SHIP:UNPACKED.
wait 0.001.

// KSP does not intelligently figure out staging on the fly here, so stage again
stage.

set SHIP:NAME to name.

SolarPanels().
Antennas().

add CreateCircularizationNode("PERI").
ExecNode().

